# UDW2020 Adpossessive Constructions


Kaius Sinnemäki and Viljami Haakana, University of Helsinki

***

This repository contains supplementary data for the following article; please cite it when using the data:

Sinnemäki, Kaius & Viljami Haakana 2020. [Variation in Universal Dependencies annotation: A token-based typological case study on adpossessive constructions](https://universaldependencies.org/udw20/papers/2020.udw2020-1.18.pdf). In *Proceedings of the Fourth Workshop on Universal Dependencies (UDW 2020)*, 158-167. Barcelona (online): The Association for Computational Linguistics.


***

## Contents

### [Supplement_S1](https://version.helsinki.fi/gramadapt/udw2020-adpossessive-constructions/-/tree/master/Supplement_S1)

A pdf-file containing descriptions of how adpossessive constructions were identified and classified in the UD treebanks. Co-authored by Viljami Haakana and Kaius Sinnemäki.


### [Supplement_S2](https://version.helsinki.fi/gramadapt/udw2020-adpossessive-constructions/-/tree/master/Supplement_S2)

Contains scripts for identifying and morphologically classifying adpossessive constructions in the UD treebanks. All Python algorithms written by Viljami Haakana.

* analyserGUIfull.py is a user interface for accessing the adpossessive constructions in the UD treebanks.
* Chinese.py is a Python script for identifying and morphologically classifying adpossessive constructions in Chinese
* conllu_reader.py is a Python script for preparing the analysis of conllu-files
* csv_functions.py is a Python script for preparing the analysis of conllu-files
* Dutch.py is a Python script for identifying and morphologically classifying adpossessive constructions in Dutch
* Finnish.py is a Python script for identifying and morphologically classifying adpossessive constructions in Finnish
* FullNPPossScript.py is a Python script that brings all analyses of individual treebanks together (the main "workhorse")
* German.py is a Python script for identifying and morphologically classifying adpossessive constructions in German
* Hebrew.py is a Python script for identifying and morphologically classifying adpossessive constructions in Hebrew
* KoreanHYPHENGSD.py is a Python script for identifying and morphologically classifying adpossessive constructions in Korean SGD treebank
* KoreanHYPHENKaist.py is a Python script for identifying and morphologically classifying adpossessive constructions in Korean Kaist treebank
* language_importer.py is a Python script for importing treebanks for each language
* Latvian.py is a Python script for identifying and morphologically classifying adpossessive constructions in Latvian
* PolishHYPHENLFG.py is a Python script for identifying and morphologically classifying adpossessive constructions in Polish LFG treebank
* PolishHYPHENSZ.py is a Python script for identifying and morphologically classifying adpossessive constructions in Polish SZ treebank
* RomanianHYPHENNonstandard.py is a Python script for identifying and classifying adpossessive constructions in Romanian Nonstandard treebank
* RomanianHYPHENRRT.py is a Python script for identifying and classifying adpossessive constructions in Romanian RRT treebank
* Russian.py is a Python script for identifying and classifying adpossessive constructions in Russian
* SurrogatePair.py is a Python script for addressing potential surrogate characters
* Swedish.py is a Python script for identifying and classifying adpossessive constructions in Swedish
* tag_chart.txt is a chart that contains UD tags for those languages which do not need a separate script
* ud_tabmodel.txt is a tab-separated text-file that contains information about the treebanks. Keys to the column names are the following:
    * id = Identifier of the treebank (ISO639.1 code + the name of the treebank if more than one treebank was sampled for a language)
    * language = Name of the language
    * folder = Folder of the treebank
    * lang_IPA = Name of the language in IPA
* Vietnamese.py is a Python script for identifying and classifying adpossessive constructions in Vietnamese


### [Supplement_S3](https://version.helsinki.fi/gramadapt/udw2020-adpossessive-constructions/-/tree/master/Supplement_S3)

A tab-separated text-file containing analyzed data on all identified and classified adpossessive constructions in our data. The data-file is produced by the algorithms in Supplement 2. Keys to the column names are the following:
* poss_no = Running number for each adpossessive construction
* id = Identifier of the treebank (ISO639.1 code + the name of the treebank if more than one treebank was sampled for a language)
* language = Name of the language
* type = Type of morphological marking of the adpossessive constructions (locus of marking)
* length1 = Length of dependency between the head and dependent in adpossessive constructions (independent words that occur between the head and the dependent and that mark the possessor as a dependent contribute to dependency length)
* length2 = Length of dependency between the head and dependent in adpossessive constructions (independent words that occur between the head and the dependent and that mark the possessor as a dependent DO NOT contribute to dependency length)
* sent_id = The identifier of the sentence in which the adpossessive construction occurs
* dep_ord = The running number of the dependent of the adpossessive construction
* head_ord = The running number of the head of the adpossessive construction
* adp_ords = The running number of an adposition that marks the possessor as a dependent
* N.puncts = The number of punctuations (they are separate tokens in UD) between the head and the dependent
* order = The word order between head and the dependent in the adpossessive construction: options are hd (head-dependent), dh (dependent-head), and NA (head only constructions)
* conj = Whether the possessor is conjoined: options are True (does contain) and False (does not contain).


The UD treebanks used in this research can be accessed from the [zip-file](http://www.christianbentz.de/MLC2019/UDtrack.zip). The file is 224MB, and as such too large to be stored at GitLab. The files were preselected by the organizers for the shared task in *The Interactive Workshop on Measuring Language Complexity (IWMLC)* held at the Freiburg Institute for Advanced Studies (FRIAS), Freiburg (Germany), 12-13 September 2019.