from conllu_reader import *

if '\\' in __file__:
    slash = '\\'
else:
    slash = '/'

LANGUAGE = __file__.split(slash)[-1][:-4]

def possessive(conllu_item, returntype=list):
    try:
        analyses = conllu_item['analyysit']
    except TypeError:
        print(conllu_item)
        return {'dep_marked':[], 'head_marked':[], 'double_marked':[], 'zero_marked':[], 'head_exist':[]}

    sent_id = conllu_item['sent_id']
    

    def find_head_index(analysis):
        head_str = analysis[6]
        head_i = int(head_str)-1
        return head_i

    dep_marked = []
    head_marked = []
    double_marked = []
    zero_marked = []
    head_exist = []

    for a in analyses: # a could be the dependent or the adposition (equivalent of 'of'),
        #which is the reason that the initial variable name is nothing more descriptive than that.
        #The name of the head variable ("head" or "dep") is supposed to be more descriptive:
        #if it's "head", then "a" is a dependent, if it's "dep", then "a" is the adposition.
        # pronouns
##        if a[3] == 'PRON' and 'Poss=Yes' in a[5] and 'PronType=Prs' in a[5] and a[7] == 'nmod:poss':
##            head_i = find_head_index(a)
##            if head_i >= 0:
##                head = analyses[head_i]
##                if head[3] in {'NOUN', 'PROPN'}:
##                    dep_marked.append(a)

        # nouns  
        if a[2] == 'of' and a[3] == 'ADP' and a[7] == 'case':
            dep_i = find_head_index(a)
            if dep_i >= 0:
                dep = analyses[dep_i]
##                if dep[3] == 'NOUN' and dep[7] == 'nmod':
##                    head_i = find_head_index(dep)
##                    if head_i >= 0:
##                        head = analyses[head_i]
##                        if head[3] in {'NOUN', 'PROPN'}:
##                            dep_marked.append(dep)
                if dep[3] == 'PROPN' and dep[7] in {'nmod', 'amod', 'nmod:poss'}:
                    head_i = find_head_index(dep)
                    if head_i >= 0:
                        head = analyses[head_i]
                        if head[3] in {'NOUN', 'PROPN'}:
                            dep_marked.append(dep)

##        if a[2] == "'s" and a[3] == 'PART' and a[7] == 'case':
##            dep_i = find_head_index(a)
##            if dep_i >= 0:
##                dep = analyses[dep_i]
####                if dep[3] == 'NOUN' and dep[7] == 'nmod:poss':
####                    head_i = find_head_index(dep)
####                    if head_i >= 0:
####                        head = analyses[head_i]
####                        if head[3] in {'NOUN', 'PROPN'}:
####                            dep_marked.append(dep)
##                if dep[3] == 'PROPN' and dep[7] in {'nmod', 'amod', 'nmod:poss'}:
##                    head_i = find_head_index(dep)
##                    if head_i >= 0:
##                        head = analyses[head_i]
##                        if head[3] in {'NOUN', 'PROPN'}:
##                            dep_marked.append(dep)
        

    return {'dep_marked':dep_marked, 'head_marked':head_marked, 'double_marked':double_marked, 'zero_marked':zero_marked, 'head_exist':head_exist}


test = r'''# sent_id = 3033
# text = Most of the dinner guests agree that Russia's internal difficulties are so grave it may have to draw away from Syria.
1	Most	many	ADJ	POS	Degree=Cmp	6	nsubj	_	_
2	of	of	ADP	_	_	5	case	_	_
3	the	the	DET	DEF	Definite=Def|PronType=Art	5	det	_	_
4	dinner	dinner	NOUN	SG-NOM	Number=Sing	5	compound	_	_
5	guests	guest	NOUN	PL-NOM	Number=Plur	1	nmod	_	_
6	agree	agree	VERB	PRES	Mood=Ind|Tense=Pres|VerbForm=Fin	0	root	_	_
7	that	that	SCONJ	_	_	14	mark	_	_
8	Russia	russia	PROPN	SG	Number=Sing	11	amod	_	SpaceAfter=No
9	's	's	PART	GEN	_	8	case	_	_
10	internal	internal	ADJ	POS	Degree=Pos	11	amod	_	_
11	difficulties	difficulty	NOUN	PL-NOM	Number=Plur	14	nsubj	_	_
12	are	be	AUX	PRES	Mood=Ind|Tense=Pres|VerbForm=Fin	14	cop	_	_
13	so	so	ADV	_	_	14	advmod	_	_
14	grave	grave	ADJ	POS	Case=Nom	6	xcomp	_	_
15	it	it	PRON	PERS-SG	_	19	nsubj	_	_
16	may	may	AUX	PRES-AUX	VerbForm=Fin	19	aux	_	_
17	have	have	AUX	INF-AUX	Mood=Ind|Tense=Pres|VerbForm=Fin	19	aux	_	_
18	to	to	PART	_	_	19	mark	_	_
19	draw	draw	VERB	INF	VerbForm=Inf	14	acl	_	_
20	away	away	ADV	_	_	19	advmod	_	_
21	from	from	ADP	_	_	22	case	_	_
22	Syria	syria	PROPN	SG-NOM	Number=Sing	19	obl	_	SpaceAfter=No
23	.	.	PUNCT	Period	_	6	punct	_	_'''

conllu_item = to_ordered_dict(test)
d = possessive(conllu_item, dict)

if __name__ == '__main__':
    if type(d) == dict:
        for item in d:
            print(item, d[item])
    else:
        for item in d:
            print(item)


def str2poss(s, returntype=dict):
    conllu_item = to_ordered_dict(s)
    return possessive(conllu_item, returntype)

def str2bea(s, returntype=dict):
    d = str2poss(s, returntype)
    if type(d) == dict:
        for item in d:
            print(item, d[item], len(d[item]))
    else:
        for item in d:
            print(item)

def str2beastr(s):
    d = str2poss(s, dict)
    answer = []
    for item in d:
        answer.append('{} {} {}'.format(item, d[item], len(d[item])))
    return '\n'.join(answer)


def strip_indent(s, i=1):
    c = []
    for j in s.splitlines():
        c.append(j[4*i:])
    return '\n'.join(c)

if __name__ == '__main__' and input('Search and save? y/n\n') == 'y':
    from language_importer import *

    imported = {i: import_thing(i) for i in ['English-EWT', 'English-GUM', 'English-LinES', 'English-ParTUT']}
    
    giig = input('filename identifier: ')
    if giig:
        giig = '-'+giig

    for jtem in imported:
        found = [w for w in imported[jtem] if possessive(to_ordered_dict(w))['dep_marked']]
    
        with open('{}-found{}.conllu'.format(jtem, giig), 'wt', encoding='utf-8') as k:
            for item in found:
                print(item, end='\n\n', file=k)
                print(str2beastr(item), end='\n\n----\n\n', file=k)

