from conllu_reader import *

if '\\' in __file__:
    slash = '\\'
else:
    slash = '/'

LANGUAGE = __file__.split(slash)[-1][:-3].replace('HYPHEN', '-')

conj = 'conj'
punct = 'PUNCT'

def possessive(conllu_item, returntype=list, subtract=False):
    """Will always return a dict, the returntype argument is a needless remnant of a previous phase of the project"""
    try:
        analyses = conllu_item['analyysit']
        nanalyses = [] #non-conj analyses
        canalyses = [] #conj analyses

        for i in analyses:
            if i[7] == conj:
                canalyses.append(i)
            else:
                nanalyses.append(i)
    except TypeError:
        print(conllu_item)
        return {'dep_marked':[], 'head_marked':[], 'double_marked':[], 'zero_marked':[], 'head_exist':[]}


    sent_id = conllu_item['sent_id']

    # Building dep_head_exist

    def find_head_index(analysis):
        head_str = analysis[6]
        head_i = int(head_str)-1
        return head_i

    dep_marked = []
    head_marked = []
    double_marked = []
    zero_marked = []
    head_exist = [] # items are heads

    for a in nanalyses:
        
        # pronouns
        # case 1

        if a[3] == 'PRON' and 'Poss=Yes' in a[5] and 'PronType=Prs' in a[5] and a[7] == 'det':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(a)

        # case 2

        elif a[3] == 'PRON' and 'Poss=Yes' in a[5] and 'PronType=Prs' in a[5] and a[7] == 'nmod':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(a)
        
        # case 3

        elif a[3] == 'PRON' and 'Case=Gen' in a[5] and 'PronType=Prs' in a[5] and 'Reflex=Yes' not in a[5] and a[7] == 'nmod':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(a)


        elif a[3] == 'PRON' and 'Case=Dat,Gen' in a[5] and 'PronType=Prs' in a[5] and 'Reflex=Yes' not in a[5] and a[7] == 'nmod':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(a)
        
        #addition June 3, 2020
        elif a[3] == 'DET' and '[psor]' in a[5] and 'PronType=Prs' in a[5] and 'Reflex=Yes' not in a[5] and a[7] == 'det':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(a)

        #addition June 3, 2020
        if a[3] == 'DET' and 'Case=Dat,Gen' in a[5] and 'PronType=Dem' in a[5]:
            part_index = int(a[0])
            dep_i = find_head_index(a)
            if dep_i >= 0:
                dep = analyses[dep_i]
                if dep[3] in {'NOUN', 'PROPN'} and dep[7] == 'nmod':
                    head_i = find_head_index(a)
                    if head_i >= 0:
                        head = analyses[head_i]
                        if head[3] in {'NOUN', 'PROPN'}:
                            dep_marked.append(dep + [part_index] if subtract else dep)
                            
                            for wd in canalyses.copy():
                            # find conjs for this "condition"
                            # Differences:
                            # assume dep is found:
                            # (start from testing the dependent, replacing dep with wd and also checking its head is dep (firstconj))
                            # dep -> wd
                            # firstconj_i
                            # replace dep(would be wd)[7] == 'nmod' with wd[6] == dep[0]
                            # append a manipulated version of the word (to_append) to calculate the dependency length correctly
                            # remove word from canalyses
                                if wd[3] in {'NOUN', 'PROPN'} and wd[6] == dep[0]:
                                    head_i = find_head_index(a)
                                    if head_i >= 0:
                                        head = analyses[head_i]
                                        if head[3] in {'NOUN', 'PROPN'}:
                                            head_position = head[0]
                                            to_append = wd[:6] + [head_position] + wd[7:]
                                            dep_marked.append(to_append + [part_index] if subtract else to_append)
                                            
                                            canalyses.remove(wd) # just for sure


        # nouns
        # case 1

        if a[2] == 'de' and a[3] == 'ADP' and 'Case=Acc' in a[5] and a[7] == 'case':
            part_index = int(a[0])
            dep_i = find_head_index(a)
            if dep_i >= 0:
                dep = analyses[dep_i]
                if dep[3] in {'NOUN', 'PROPN'} and dep[7] == 'nmod':
                    head_i = find_head_index(a)
                    if head_i >= 0:
                        head = analyses[head_i]
                        if head[3] in {'NOUN', 'PROPN'}:
                            dep_marked.append(dep + [part_index] if subtract else dep)
                            
                            for wd in canalyses.copy():
                            # find conjs for this "condition"
                            # Differences:
                            # assume dep is found:
                            # (start from testing the dependent, replacing dep with wd and also checking its head is dep (firstconj))
                            # dep -> wd
                            # firstconj_i
                            # replace dep(would be wd)[7] == 'nmod' with wd[6] == dep[0]
                            # append a manipulated version of the word (to_append) to calculate the dependency length correctly
                            # remove word from canalyses
                                if wd[3] in {'NOUN', 'PROPN'} and wd[6] == dep[0]:
                                    head_i = find_head_index(a)
                                    if head_i >= 0:
                                        head = analyses[head_i]
                                        if head[3] in {'NOUN', 'PROPN'}:
                                            head_position = head[0]
                                            to_append = wd[:6] + [head_position] + wd[7:]
                                            dep_marked.append(to_append + [part_index] if subtract else to_append)
                                            
                                            canalyses.remove(wd) # just for sure

        # added on May 29, 2020 based on "școla a unui tirean" from train-6055
        if a[2] == 'un' and a[3] == 'DET' and 'Case=Dat,Gen' in a[5] and 'PronType=Ind' in a[5] and a[7] == 'det':
            part_index = int(a[0])
            dep_i = find_head_index(a)
            if dep_i >= 0:
                dep = analyses[dep_i]
                if dep[3] in {'NOUN', 'PROPN'} and dep[7] == 'nmod':
                    head_i = find_head_index(a)
                    if head_i >= 0:
                        head = analyses[head_i]
                        if head[3] in {'NOUN', 'PROPN'}:
                            dep_marked.append(dep + [part_index] if subtract else dep)
                            
                            for wd in canalyses.copy():
                            # find conjs for this "condition"
                            # Differences:
                            # assume dep is found:
                            # (start from testing the dependent, replacing dep with wd and also checking its head is dep (firstconj))
                            # dep -> wd
                            # firstconj_i
                            # replace dep(would be wd)[7] == 'nmod' with wd[6] == dep[0]
                            # append a manipulated version of the word (to_append) to calculate the dependency length correctly
                            # remove word from canalyses
                                if wd[3] in {'NOUN', 'PROPN'} and wd[6] == dep[0]:
                                    head_i = find_head_index(a)
                                    if head_i >= 0:
                                        head = analyses[head_i]
                                        if head[3] in {'NOUN', 'PROPN'}:
                                            head_position = head[0]
                                            to_append = wd[:6] + [head_position] + wd[7:]
                                            dep_marked.append(to_append + [part_index] if subtract else to_append)
                                            
                                            canalyses.remove(wd) # just for sure
        
        # case 2

        elif a[2] == 'al' and a[3] == 'DET' and 'Poss=Yes' in a[5] and 'PronType=Art' in a[5] and a[7] == 'det':
            part_index = int(a[0])
            dep_i = find_head_index(a)
            if dep_i >= 0:
                dep = analyses[dep_i]
                if dep[3] in {'NOUN', 'PROPN'} and dep[7] == 'nmod':
                    head_i = find_head_index(a)
                    if head_i >= 0:
                        head = analyses[head_i]
                        if head[3] in {'NOUN', 'PROPN'}:
                            dep_marked.append(dep + [part_index] if subtract else dep)
                            
                            for wd in canalyses.copy():
                            # find conjs for this "condition"
                            # Differences:
                            # assume dep is found:
                            # (start from testing the dependent, replacing dep with wd and also checking its head is dep (firstconj))
                            # dep -> wd
                            # firstconj_i
                            # replace dep(would be wd)[7] == 'nmod' with wd[6] == dep[0]
                            # append a manipulated version of the word (to_append) to calculate the dependency length correctly
                            # remove word from canalyses
                                if wd[3] in {'NOUN', 'PROPN'} and wd[6] == dep[0]:
                                    head_i = find_head_index(a)
                                    if head_i >= 0:
                                        head = analyses[head_i]
                                        if head[3] in {'NOUN', 'PROPN'}:
                                            head_position = head[0]
                                            to_append = wd[:6] + [head_position] + wd[7:]
                                            dep_marked.append(to_append + [part_index] if subtract else to_append)
                                            
                                            canalyses.remove(wd) # just for sure
        
        # case 3

        elif a[3] in {'NOUN', 'PROPN'} and 'Case=Dat,Gen' in a[5] and a[7] == 'nmod':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if not any(w for w in analyses if w[6] == a[0] and w[2] == 'al' and w[3] == 'DET' and 'Poss=Yes' in w[5] and 'PronType=Art' in w[5] and w[7] == 'det'):
                    #previous check added on September 3, 2019. Should not matter though, as duplicates are removed.
                    if head[3] in {'NOUN', 'PROPN'}:
                        dep_marked.append(a)
        
        # case 4

        elif a[3] in {'NOUN', 'PROPN'} and 'Case=Gen' in a[5] and a[7] == 'nmod':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(a)

        #'-ul' possibility added on May 29, 2020
        elif a[2] in {'lui', '-ul'} and a[3] == 'DET' and 'Case=Dat,Gen' in a[5] and 'PronType=Art' in a[5] and a[7] == 'det':
            part_index = int(a[0])
            dep_i = find_head_index(a)
            if dep_i >= 0:
                dep = analyses[dep_i]
                # there can't be a word whose head is dep and which meets the following conditions: [compare case 2]
                # lemma = al, POS = DET, tag contains Poss=Yes and PronType=Art, synt = det
                if not any(w for w in analyses if w[6] == dep[0] and w[2] == 'al' and w[3] == 'DET' and 'Poss=Yes' in w[5] and 'PronType=Art' in w[5] and w[7] == 'det'):
                    if dep[3] in {'NOUN', 'PROPN'} and dep[7] == 'nmod':
                        head_i = find_head_index(dep)
                        if head_i >= 0:
                            head = analyses[head_i]
                            if head[3] in {'NOUN', 'PROPN'}:
                                dep_marked.append(dep + [part_index] if subtract else dep)
                                
                                for wd in canalyses.copy():
                                # find conjs for this "condition"
                                # Differences:
                                # assume dep is found:
                                # (start from testing the dependent, replacing dep with wd and also checking its head is dep (firstconj))
                                # dep -> wd
                                # firstconj_i
                                # replace dep(would be wd)[7] == 'nmod' with wd[6] == dep[0]
                                # append a manipulated version of the word (to_append) to calculate the dependency length correctly
                                # remove word from canalyses
                                    if wd[3] in {'NOUN', 'PROPN'} and wd[6] == dep[0]:
                                        if any(w for w in analyses if w[6] == wd[0] and w[2] == 'al' and w[3] == 'DET' and 'Poss=Yes' in w[5] and 'PronType=Art' in w[5] and w[7] == 'det'):
                                            continue # this statement was added manually after the rewriter function had written everything else in this particular for wd in... loop.
                                        firstconj = dep
                                        head_i = find_head_index(firstconj)
                                        if head_i >= 0:
                                            head = analyses[head_i]
                                            if head[3] in {'NOUN', 'PROPN'}:
                                                head_position = head[0]
                                                to_append = wd[:6] + [head_position] + wd[7:]
                                                dep_marked.append(to_append + [part_index] if subtract else to_append)
                                                
                                                canalyses.remove(wd) # just for sure


    # almost copy-paste code.
    # Differences:
    # -firstconj lines
    # -canalyses instead of nanalyses
    # -a[7] replaced with firstconj[7]
    # -appending an edited version of the dependent
    # -skipping adpositions and others whose checking processes don't start with the dependent

    def appendable(firstconj, conj_a):
        return conj_a[:6] + [firstconj[6]] + conj_a[7:]

    for a in canalyses:
        firstconj_i = find_head_index(a)
        firstconj = analyses[firstconj_i]
        
        if firstconj_i < 0:
            continue # skip if conj refers to root
        if firstconj not in dep_marked+head_marked+double_marked+zero_marked:
            continue # skip if conj's head not any found possessive NP's dependent
        

        
        # pronouns
        # case 1

        if a[3] == 'PRON' and 'Poss=Yes' in a[5] and 'PronType=Prs' in a[5] and firstconj[7] == 'det':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(appendable(firstconj, a))

        # case 2

        elif a[3] == 'PRON' and 'Poss=Yes' in a[5] and 'PronType=Prs' in a[5] and firstconj[7] == 'nmod':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(appendable(firstconj, a))
        
        # case 3

        elif a[3] == 'PRON' and 'Case=Gen' in a[5] and 'PronType=Prs' in a[5] and 'Reflex=Yes' not in a[5] and firstconj[7] == 'nmod':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(appendable(firstconj, a))


        elif a[3] == 'PRON' and 'Case=Dat,Gen' in a[5] and 'PronType=Prs' in a[5] and 'Reflex=Yes' not in a[5] and firstconj[7] == 'nmod':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(appendable(firstconj, a))

        # addition June 3, 2020
        elif a[3] == 'DET' and '[psor]' in a[5] and 'PronType=Prs' in a[5] and 'Reflex=Yes' not in a[5] and firstconj[7] == 'det':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(appendable(firstconj, a))
        
        # case 3

        elif a[3] in {'NOUN', 'PROPN'} and 'Case=Dat,Gen' in a[5] and firstconj[7] == 'nmod':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if not any(w for w in analyses if w[6] == a[0] and w[2] == 'al' and w[3] == 'DET' and 'Poss=Yes' in w[5] and 'PronType=Art' in w[5] and w[7] == 'det'):
                    #previous check added on September 3, 2019. Should not matter though, as duplicates are removed.
                    if head[3] in {'NOUN', 'PROPN'}:
                        dep_marked.append(appendable(firstconj, a))
        
        # case 4

        elif a[3] in {'NOUN', 'PROPN'} and 'Case=Gen' in a[5] and firstconj[7] == 'nmod':
            head_i = find_head_index(a)
            if head_i >= 0:
                head = analyses[head_i]
                if head[3] in {'NOUN', 'PROPN'}:
                    dep_marked.append(appendable(firstconj, a))

    answer = remove_duplicates({'dep_marked':dep_marked, 'head_marked':head_marked, 'double_marked':double_marked, 'zero_marked':zero_marked, 'head_exist':head_exist})

    for marking in answer: # copy-paste from tagchart_script. Adds number of PUNCTs between head and dependent as an int to the end of each dict value.
        # Replacing lause with conllu_item, kieli with LANGUAGE. Original lause['sent_id'] is now just sent_id.
        if marking == 'head_exist':
            for n, head in enumerate(answer[marking]):
                answer[marking][n].append(0)
        else:
            for n, dep in enumerate(answer[marking]):

                #lst[m:n] will return from m+1th element up to nth.
                #since we want from this+1st to head-1st, or head+1st to this-1st,
                #1 will be subtracted from the LARGER number in order to get the correct indices.
                
                
                this_i = int(dep[0])
                head_i = int(dep[6])
                # only those in between will be checked
                if this_i > head_i:
                    this_i -= 1
                elif this_i < head_i:
                    head_i -= 1
                else:
                    raise AssertionError("Head and dependent have the same ordinal: {} from {}".format(LANGUAGE, sent_id))
                if not (this_i >= 0 and head_i >= 0):
                    raise AssertionError("Head or dependent is root: {} from {}".format(LANGUAGE, sent_id))

                start = min(this_i, head_i)
                stop = max(this_i, head_i)

                answer[marking][n].append(len([w for w in conllu_item['analyysit'][start:stop] if w[3] == punct]))

    return answer




test = r'''# sent_id = train-3787
# text = Feriți-vă să nu cumva să se îngreuieze inimile voastre cu sațiul mîncării și bețiii și cu grijile ceștii lumi, și degrabă să vie zuoa aceaia.
# citation-part=LUCA 21.34
1	Feriți-	feri	VERB	Vmm-2p	Mood=Imp|Number=Plur|Person=2|VerbForm=Fin	0	root	_	ref=LUCA21.34|SpaceAfter=No
2	vă	tu	PRON	Pp2-pa--------w	Case=Acc|Number=Plur|Person=2|PronType=Prs|Strength=Weak	1	obj	_	ref=LUCA21.34
3	să	să	PART	Qs	PartType=Sub	5	mark	_	ref=LUCA21.34
4	nu	nu	ADV	Qz	Polarity=Neg	5	advmod	_	ref=LUCA21.34
5	cumva	cumva	ADV	Rg	_	1	ccomp:pmod	_	ref=LUCA21.34
6	să	să	PART	Qs	PartType=Sub	8	mark	_	ref=LUCA21.34
7	se	sine	PRON	Px3--a--------w	Case=Acc|Person=3|PronType=Prs|Strength=Weak	8	expl:pv	_	ref=LUCA21.34
8	îngreuieze	îngreuia	VERB	Vmsp3	Mood=Sub|Person=3|Tense=Pres|VerbForm=Fin	5	csubj	_	ref=LUCA21.34
9	inimile	inimă	NOUN	Ncfpry	Case=Acc,Nom|Definite=Def|Gender=Fem|Number=Plur	8	nsubj	_	ref=LUCA21.34
10	voastre	tău	DET	Ds2fp-p	Gender=Fem|Number=Plur|Number[psor]=Plur|Person=2|PronType=Prs	9	det	_	ref=LUCA21.34
11	cu	cu	ADP	Spsa	AdpType=Prep|Case=Acc	12	case	_	ref=LUCA21.34
12	sațiul	sațiu	NOUN	Ncmsry	Case=Acc,Nom|Definite=Def|Gender=Masc|Number=Sing	8	obl	_	ref=LUCA21.34
13	mîncării	mâncare	NOUN	Ncfsoy	Case=Dat,Gen|Definite=Def|Gender=Fem|Number=Sing	12	nmod	_	ref=LUCA21.34
14	și	și	CCONJ	Ccssp	Polarity=Pos	15	cc	_	ref=LUCA21.34
15	bețiii	bețiii	NOUN	Ncmpry	Case=Acc,Nom|Definite=Def|Gender=Masc|Number=Plur	13	conj	_	ref=LUCA21.34
16	și	și	CCONJ	Ccssp	Polarity=Pos	18	cc	_	ref=LUCA21.34
17	cu	cu	ADP	Spsa	AdpType=Prep|Case=Acc	18	mark	_	ref=LUCA21.34
18	grijile	grijă	NOUN	Ncfpry	Case=Acc,Nom|Definite=Def|Gender=Fem|Number=Plur	12	conj	_	ref=LUCA21.34
19	ceștii	acesta	DET	Dd3fso---e	Case=Dat,Gen|Gender=Fem|Number=Sing|Person=3|Position=Prenom|PronType=Dem	18	nmod	_	ref=LUCA21.34
20	lumi	lume	NOUN	Ncfson	Case=Dat,Gen|Definite=Ind|Gender=Fem|Number=Sing	19	nmod	_	ref=LUCA21.34|SpaceAfter=No
21	,	,	PUNCT	COMMA	_	25	punct	_	ref=LUCA21.34
22	și	și	CCONJ	Ccssp	Polarity=Pos	25	cc	_	ref=LUCA21.34
23	degrabă	degrabă	ADV	Rg	_	25	advmod:tmod	_	ref=LUCA21.34
24	să	să	PART	Qs	PartType=Sub	25	mark	_	ref=LUCA21.34
25	vie	veni	VERB	Vmsp3s	Mood=Sub|Number=Sing|Person=3|Tense=Pres|VerbForm=Fin	8	conj	_	ref=LUCA21.34
26	zuoa	zi	NOUN	Ncfsry	Case=Acc,Nom|Definite=Def|Gender=Fem|Number=Sing	25	nsubj	_	ref=LUCA21.34
27	aceaia	acela	DET	Dd3fsr	Case=Acc,Nom|Gender=Fem|Number=Sing|Person=3|PronType=Dem	26	det	_	ref=LUCA21.34|SpaceAfter=No
28	.	.	PUNCT	PERIOD	_	1	punct	_	ref=LUCA21.34'''

conllu_item = to_ordered_dict(test)
d = possessive(conllu_item, dict)

if __name__ == '__main__':
    if type(d) == dict:
        for item in d:
            print(item, d[item])
    else:
        for item in d:
            print(item)


def str2poss(s, returntype=list):
    conllu_item = to_ordered_dict(s)
    return possessive(conllu_item, returntype)

def str2bea(s, returntype=list):
    d = str2poss(s, returntype)
    if type(d) == dict:
        for item in d:
            print(item, d[item], len(d[item]))
    else:
        for item in d:
            print(item)


def strip_indent(s, i=1):
    c = []
    for j in s.splitlines():
        c.append(j[4*i:])
    return '\n'.join(c)

