import FullNPPossScript as et
from language_importer import *
#import Swedish as lng

from unicodedata import name
from tkinter import *
from tkinter import messagebox # For some reason this seemst to be necessary
from tkinter.ttk import Combobox
from collections import Counter
import tkinter.filedialog
import os
from SurrogatePair import remove_surrogates, with_surrogates

filedialog = tkinter.filedialog

root = Tk()
root.title('possessives from "conllu" data')

label = Label(root, text='Enter sentence you wish to analyse')
label.grid(row=0, column=0)

label2 = Label(root, text='The analyses will appear here when you click "Analyse"')
label2.grid(row=0, column=1)

lahe = Text(root, width=50)
lahe.grid(row=1, column=0)

analyysi = Text(root, width=50)
analyysi.grid(row=1, column=1)

#names = lang2ipa # language: ˈlæŋgwɪdʒ
#nimet = ipa2lang # ˈlæŋgwɪdʒ: language

kielet = sorted([w for w in os.listdir('UDtrack') if w.startswith('UD_') and '.' not in w])

kielivaihtoehot = Combobox(values=kielet)
kielivaihtoehot.grid(row=1, column=2, sticky=N)
Label(root, text='Select material:').grid(row=0, column=2)


while 'UDtrack' in os.listdir():
    os.chdir('UDtrack')

g = [] # strings

indeksi = None

def analysoi(s):
    """Analyse a string (to string representing a dict of possessive NPs from a conllu string s)."""
    try:
        return et.str2bea(remove_surrogates(s), kielivaihtoehot.get()[3:])
    except:
        return analyysi.get("1.0","end-1c")

def set_text(entry, text):
    entry.delete(0,END)
    entry.insert(0,text)

def kf():
    """Analyse current sentence and insert it to the box on the right."""
    global indeksi
    analyysi.delete('1.0', END)
    if remove_surrogates(lahe.get("1.0","end-1c").strip()) in g: # change browsing index if sentence is in material
        indeksi = g.index(remove_surrogates(lahe.get("1.0","end-1c").strip()))
    analyysi.insert(END, with_surrogates(analysoi(lahe.get("1.0","end-1c"))))


lause_id_entry = Entry(root) # search box for sent_id
lause_id_entry.grid(row=2, column=0)



komento = Button(root, text='Analyse', command=kf) # analyse button
komento.grid(columnspan=2)

def eellinen_lause(): # previous sentence
    global indeksi

    if indeksi is None:
        messagebox.showinfo('Error', "The sentence hasn't been defined yet. Use the search box first to find a sentence.")
        return None

    indeksi -= 1
    
    if indeksi < 0:
        messagebox.showinfo('Error', 'This is the first sentence.')
        indeksi = 0
        return None
    
    lahe.delete('1.0', END)
    lahe.insert(END, g[indeksi])
    kf()

def seurraava_lause(): # next sentence
    global indeksi

    if indeksi is None:
        messagebox.showinfo('Error', "The sentence hasn't been defined yet. Use the search box first to find a sentence.")
        return None

    indeksi += 1
    
    if indeksi >= len(g):
        messagebox.showinfo('Error', 'This is the last sentence.')
        indeksi = len(g)-1
        return None
    
    lahe.delete('1.0', END)
    lahe.insert(END, g[indeksi])
    kf()

nyk_material = ''

def hae_lause(): # find sentence
    global indeksi
    global g
    global nyk_material
    teksti = lause_id_entry.get()
    loyv = []
    
    nyk_material = kielivaihtoehot.get() # find current language IPA -> orthography
    if nyk_material:
        ng = import_thing(nyk_material)
    else:
        #raise KeyError('')
        return messagebox.showinfo('Select language', 'Select first the language and then search for a sentence')
    for n, i in enumerate(ng):
        d = i.index('# sent_id = ')
        sentid = i[d:][12:].splitlines()[0]
        if sentid.startswith(teksti) or sentid.lstrip().startswith(teksti):
            if not loyv:
                lahe.delete('1.0', END)
                lahe.insert(END, i)
                indeksi = n
                kf()
            elif sentid == teksti or sentid.lstrip() == teksti:
                lahe.delete('1.0', END)
                lahe.insert(END, i)
                indeksi = n
                kf()
            loyv.append(sentid)
    #print(len(loyv))
    if not loyv:
        messagebox.showinfo("Can't find", "Can't find sentence with given ID.")
    elif 1 < len(loyv) <= 10:
        messagebox.showinfo("Found more than one, here's the first", 'Found sentences with following IDs:\n' + '\n'.join(repr(i) for i in loyv))
    elif len(loyv) == 11:
        messagebox.showinfo("Found more than one, here's the first", 'Found sentences with following IDs:\n' + '\n'.join(repr(i) for i in loyv[:10]) + '\nand one more')
    elif len(loyv) > 11:
        messagebox.showinfo("Found more than one, here's the first", 'Found sentences with following IDs:\n' + '\n'.join(repr(i) for i in loyv[:10]) + '\nand {} ˈmore'.format(len(loyv)-10))

    g.clear()
    g.extend(ng)

eellinen = Button(root, text='Previous', command=eellinen_lause)
eellinen.grid(row=4, column=0)
hae = Button(root, text='Search', command=hae_lause)
hae.grid(row=3, column=0)
seurraava = Button(root, text='Next', command=seurraava_lause)
seurraava.grid(row=4, column=1)

merkintaluokat = ['dep_marked', 'double_marked', 'head_marked', 'zero_marked', 'head_exist']
ekavika = ['th', 'th last']

def hae_merkintatyypin_mukkaan():
    """Find by type of marking (e.g. find first sentence with at least one dependent-marked possessive NP)."""
    global indeksi
    global g
    global nyk_material
    
    if kielivaihtoehot.get():
        nyk_material = kielivaihtoehot.get()
        g.clear()
        g.extend(import_thing(nyk_material))
        ##language = folder2ipa[nyk_material] # needed only for GUI written in IPA
        indeksi = 0
    else:
        return messagebox.showinfo("Material hasn't been chosen", 'Chose first the material and then try again!')
    
    ikkuna = Toplevel()
    ##ikkuna.title('Find sentence in "{}" ({})'.format(nyk_material, language))
    ikkuna.title('Find sentence in "{}"'.format(nyk_material)) # previous line used instead of this in GUI written in IPA
    #search
    tyyppi_label1 = Label(ikkuna, text='Find')
    tyyppi_label1.grid(row=0, column=0, sticky=E)
    #whichth
    monesko = Entry(ikkuna, width=6)
    monesko.grid(row=0, column=1)
    set_text(monesko, '1')
    #from the end?
    ekavikabox = Combobox(ikkuna, values=ekavika)
    ekavikabox.grid(row=0, column=2)
    ekavikabox.current(0)
    #containing
    Label(ikkuna, text='containing').grid(row=0, column=3)
    #which type of marking the user wants to search for
    mlbox = Combobox(ikkuna, values=merkintaluokat)
    mlbox.grid(row=0, column=4)

    # browse only these?
    # If tickbox is crossed, previous and next buttons will only show sentences containing the searched type of possessive NPs.
    sellaavar = IntVar() # browse
    sellaa = Checkbutton(ikkuna, text="Browse only these", variable=sellaavar)
    sellaa.grid(row=1, column=0)
    
    def haku(): # actual search
        nonlocal ikkuna
        if ekavikabox.get() == 'th':
            i = 0
            add = 1
        else:
            i = -1
            add = -1


        try:
            nn = int(monesko.get())
            assert nn > 0
        except:
            return messagebox.showinfo('Error', '{} is not a positive integer.'.format(monesko.get()))

        loyv = []

        mlbox_arvo = mlbox.get()
        if not mlbox_arvo:
            return messagebox.showinfo("Choose what type you're looking for", 'Choose first which type of marking you want to find.'.format(monesko.get()))

        
        if sellaavar.get(): # everything under this "if" statement must end in return statements,
            c = [] # the "while True" loop below is only for cases where the user wants to browse the entire material
            for lause in g:
                vastaus = et.possessiivi(et.to_ordered_dict(lause), nyk_material[3:])
                if mlbox_arvo in vastaus and vastaus[mlbox_arvo] and vastaus[mlbox_arvo] != et.NA:
                    c.append(lause)
            if not c:
                ikkuna.destroy()
                return messagebox.showinfo("Can't find any", 'The type of marking you chose does not appear in the material.')
            
            g.clear()
            g.extend(c)
            if add == 1:
                virhe = False
                try:
                    nyk_lause = g[nn-1]
                    indeksi = nn-1
                except IndexError:
                    nyk_lause = g[-1]
                    indeksi = len(g)-1
                    virhe = True
                lahe.delete('1.0', END)
                lahe.insert(END, g[indeksi])
                kf()
                ikkuna.destroy()
                if virhe:
                    return messagebox.showinfo("Can't find that many", "The type of marking you chose does not appear in the material that many times, here's the last one.")
            else:
                virhe = False
                try:
                    nyk_lause = g[nn]
                    indeksi = g.index(nyk_lause)
                except IndexError:
                    nyk_lause = g[0]
                    indeksi = 0
                    virhe = True
                lahe.delete('1.0', END)
                lahe.insert(END, g[indeksi])
                kf()
                ikkuna.destroy()
                if virhe:
                    return messagebox.showinfo("Can't find that many", "The type of marking you chose does not appear in the material that many times, here's the first one.")
        
        while True:
            try:
                lause = g[i]
                vastaus = et.possessiivi(et.to_ordered_dict(lause), nyk_material[3:])
                if mlbox_arvo in vastaus and vastaus[mlbox_arvo]:
                    #print(i, add, lause, vastaus)
                    loyv.append(lause)
                if len(loyv) == nn:
                    if add == 1:
                        indeksi = i
                    else:
                        indeksi = len(g)+i
                    assert indeksi >= 0
                    lahe.delete('1.0', END)
                    lahe.insert(END, g[indeksi])
                    kf()
                    ikkuna.destroy()
                    break
                i += add
            except IndexError:
                if loyv:
                    lause = loyv[-1]
                    indeksi = g.index(lause)
                    lahe.delete('1.0', END)
                    lahe.insert(END, g[indeksi])
                    kf()
                    ikkuna.destroy()
                    if add == 1:
                        return messagebox.showinfo("Can't find that many", "The type of marking you chose does not appear in the material that many times, here's the last one.")
                    else:
                        return messagebox.showinfo("Can't find that many", "The type of marking you chose does not appear in the material that many times, here's the first one.")
                else:
                    ikkuna.destroy()
                    return messagebox.showinfo("Can't find that many", 'The type of marking you chose does not appear in the material.')
                    
            
            ikkuna.destroy()
    
    ok = Button(ikkuna, text='  OK  ', command=haku)
    ok.grid(columnspan=5, row=1)#, sticky=W)

def show_entire_nps():
    """show entire NPs: insert to analysis Text all possessive NPs found in the sentence line by line"""
    sent = lahe.get("1.0","end-1c")
    conllu_item = et.to_ordered_dict(remove_surrogates(sent))
    dikt = et.possessiivi(conllu_item, kielivaihtoehot.get()[3:])
    answer = []

    if kielivaihtoehot.get()[3:].startswith('Chinese'):
        joins = ''
    else:
        joins = ' '

    for dep in dikt['dep_marked'] + dikt['double_marked'] + dikt['head_marked'] + dikt['zero_marked']:
        head_i = int(dep[6])-1
        dep_i = int(dep[0])-1

        if head_i > dep_i:
            answer.append(joins.join(j[1] for j in conllu_item['analyysit'][dep_i:head_i+1]))
        else:
            answer.append(joins.join(j[1] for j in conllu_item['analyysit'][head_i:dep_i+1]))

    for head in dikt['head_exist']:
        answer.append(head[1])

    analyysi.delete('1.0', END)
    analyysi.insert(END, with_surrogates('\n'.join(answer)))
        
    

haens = Button(root, text='Search by marking...', command=hae_merkintatyypin_mukkaan)
haens.grid(row=3, column=1)

shownps = Button(root, text='Show entire NPs', command=show_entire_nps)
shownps.grid(row=4, columnspan=2)


root.mainloop()

